#include "counter.h"
#include "color-observer.h"
#include "draw.h"

using namespace obsevers;

class CountObserver : NonCopyable
{
    uint16_t m_c;

public:
    void observe(char aButton) {
        draw::str_hex(draw::PAGE_4, "total clicks:", ++m_c);
    }
};

static buttons::Adapter<CountObserver> observer;

namespace tasks {

    namespace counter {

        void start() {
          buttons::event.addObserver(&observer);
        }

    }

}